package benchmark.random.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.io.File;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import benchmark.random.RBDisCSPGenerator;
import gui.generators.Generator;

public class RandomDisCSPGeneratorPanel extends Generator {

	public static final long serialVersionUID = 1L;
	private JPanel principalPanel = null;
	public JLabel nbInstanceLabel = null;
	public JLabel nbAgentLabel = null;
	public JLabel domainSizeLabel = null;
	public JLabel P1Label = null;
	public JLabel P2Label = null;
	public JLabel fromLabel = null;
	public JLabel toLabel = null;
	public JLabel stepLabel = null;
	public JSpinner minP1 = null;
	public JSpinner maxP1 = null;
	public JSpinner stepP1 = null;
	public JSpinner minP2 = null;
	public JSpinner maxP2 = null;
	public JSpinner stepP2 = null;
	private JSpinner nbInstance = null;
	private JSpinner nbAgents = null;
	private JSpinner domainSize = null;
	private JComboBox constraintsModel = null;

	private static String totally = "Totally Known Costraint";
	private static String partially = "Partially Known Costraint";

	/**
	 * This is the default constructor
	 */
	public RandomDisCSPGeneratorPanel() {
		super();
		this.add(this.getPrincipalPanel(), BorderLayout.CENTER);
	}

	/**
	 * This method initializes principalPanel
	 * 
	 * @return simulation.gui.RandomTKCPanel
	 */
	protected JPanel getPrincipalPanel() {
		if (principalPanel == null) {
			principalPanel = new JPanel();
			initializeLabel();
			principalPanel.setLayout(null);
			principalPanel.setPreferredSize(new Dimension(400, 375));
			principalPanel.setMinimumSize(new Dimension(400, 375));
			principalPanel.add(nbInstanceLabel, null);
			principalPanel.add(nbAgentLabel, null);
			principalPanel.add(domainSizeLabel, null);
			principalPanel.add(getDomainSize(), null);
			principalPanel.add(P1Label, null);
			principalPanel.add(P2Label, null);
			principalPanel.add(fromLabel, null);
			principalPanel.add(toLabel, null);
			principalPanel.add(stepLabel, null);
			principalPanel.add(getMinP1(), null);
			principalPanel.add(getMaxP1(), null);
			principalPanel.add(getStepP1(), null);
			principalPanel.add(getMinP2(), null);
			principalPanel.add(getMaxP2(), null);
			principalPanel.add(getStepP2(), null);
			principalPanel.add(getNbInstance(), null);
			principalPanel.add(getNbAgents(), null);
			principalPanel.add(getConstraintsModel(), null); // Generated
		}
		return principalPanel;
	}

	private void initializeLabel() {
		P1Label = new JLabel();
		P1Label.setBounds(new Rectangle(5, 215, 140, 22));
		P1Label.setText("constraint density");
		P1Label.setHorizontalAlignment(JLabel.RIGHT);
		P2Label = new JLabel();
		P2Label.setBounds(new Rectangle(5, 250, 140, 22));
		P2Label.setText("constraints tightness");
		P2Label.setHorizontalAlignment(JLabel.RIGHT);
		fromLabel = new JLabel();
		fromLabel.setBounds(new Rectangle(155, 180, 50, 22));
		fromLabel.setText("From");
		fromLabel.setHorizontalAlignment(JLabel.CENTER);
		toLabel = new JLabel();
		toLabel.setBounds(new Rectangle(225, 180, 50, 22));
		toLabel.setText("To");
		toLabel.setHorizontalAlignment(JLabel.CENTER);
		stepLabel = new JLabel();
		stepLabel.setBounds(new Rectangle(295, 180, 50, 22));
		stepLabel.setText("Step");
		stepLabel.setHorizontalAlignment(JLabel.CENTER);
		nbInstanceLabel = new JLabel();
		nbInstanceLabel.setBounds(new Rectangle(85, 65, 150, 22));
		nbInstanceLabel.setHorizontalAlignment(JLabel.RIGHT);
		nbInstanceLabel.setText("Number of instance");
		nbAgentLabel = new JLabel();
		nbAgentLabel.setBounds(new Rectangle(85, 100, 150, 22));
		nbAgentLabel.setHorizontalAlignment(JLabel.RIGHT);
		nbAgentLabel.setText("Number of Agents");
		domainSizeLabel = new JLabel();
		domainSizeLabel.setBounds(new Rectangle(85, 135, 150, 22));
		domainSizeLabel.setHorizontalAlignment(JLabel.RIGHT);
		domainSizeLabel.setText("Domain Size");
	}

	/**
	 * This method initializes minP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinP1() {
		if (minP1 == null) {
			minP1 = new JSpinner(new SpinnerNumberModel(0.20, 0.01, 1, 0.01));
			minP1.setBounds(new Rectangle(150, 215, 60, 22));
		}
		return minP1;
	}

	/**
	 * This method initializes maxP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxP1() {
		if (maxP1 == null) {
			maxP1 = new JSpinner(new SpinnerNumberModel(0.80, 0.01, 1, 0.01));
			maxP1.setBounds(new Rectangle(220, 215, 60, 22));
		}
		return maxP1;
	}

	/**
	 * This method initializes stepP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepP1() {
		if (stepP1 == null) {
			stepP1 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			stepP1.setBounds(new Rectangle(290, 215, 60, 22));
		}
		return stepP1;
	}

	/**
	 * This method initializes minP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinP2() {
		if (minP2 == null) {
			minP2 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			minP2.setBounds(new Rectangle(150, 250, 60, 22));
		}
		return minP2;
	}

	/**
	 * This method initializes maxP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxP2() {
		if (maxP2 == null) {
			maxP2 = new JSpinner(new SpinnerNumberModel(0.90, 0.01, 1, 0.01));
			maxP2.setBounds(new Rectangle(220, 250, 60, 22));
		}
		return maxP2;
	}

	/**
	 * This method initializes stepP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepP2() {
		if (stepP2 == null) {
			stepP2 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			stepP2.setBounds(new Rectangle(290, 250, 60, 22));
		}
		return stepP2;
	}

	public void generate(File file) {
		int nbInstance = (Integer) (getNbInstance().getValue());
		int nbAgent = (Integer) (getNbAgents().getValue());
		int domainSize = (Integer) (getDomainSize().getValue());
		double minP1 = (Double) (this.getMinP1().getValue());
		double maxP1 = (Double) (this.getMaxP1().getValue());
		double stepP1 = (Double) (this.getStepP1().getValue());
		double minP2 = (Double) (this.getMinP2().getValue());
		double maxP2 = (Double) (this.getMaxP2().getValue());
		double stepP2 = (Double) (this.getStepP2().getValue());
		if (minP1 > 100 || maxP1 > 100 || stepP1 > 100 || minP2 > 100 || maxP2 > 100 || stepP2 > 100 || minP1 < 0 || maxP1 < 0 || stepP1 < 0
				|| minP2 < 0 || maxP2 < 0 || stepP2 < 0) {
			JOptionPane.showMessageDialog(this, "Set parameters correctly", "DisChoco", JOptionPane.WARNING_MESSAGE);
			return;
		}
		RBDisCSPGenerator g = new RBDisCSPGenerator(file, nbInstance, nbAgent, domainSize);
		g.setProperties(minP1, maxP1, stepP1, minP2, maxP2, stepP2);
		String model = (String) this.getConstraintsModel().getSelectedItem();
		g.setModel(model.equals(totally));
		g.generate();
		file = null;
		JOptionPane.showMessageDialog(this, "Problems was generated with success");
		return;
	}

	/**
	 * This method initializes nbInstance
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getNbInstance() {
		if (nbInstance == null) {
			nbInstance = new JSpinner(new SpinnerNumberModel(25, 1, 200, 1));
			nbInstance.setBounds(new Rectangle(250, 65, 60, 22));
		}
		return nbInstance;
	}

	/**
	 * This method initializes nbAgents
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getNbAgents() {
		if (nbAgents == null) {
			nbAgents = new JSpinner(new SpinnerNumberModel(20, 5, 50, 1));
			nbAgents.setBounds(new Rectangle(250, 100, 60, 22));
		}
		return nbAgents;
	}

	/**
	 * This method initializes domainSize
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getDomainSize() {
		if (domainSize == null) {
			domainSize = new JSpinner(new SpinnerNumberModel(10, 5, 30, 1));
			domainSize.setBounds(new Rectangle(250, 135, 60, 22));
		}
		return domainSize;
	}

	/**
	 * This method initializes constraintsModel
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getConstraintsModel() {
		if (constraintsModel == null) {
			String[] models = {totally, partially};
			constraintsModel = new JComboBox(models);
			constraintsModel.setSelectedItem(totally);
			constraintsModel.setBounds(new Rectangle(100, 15, 250, 24)); // Generated
		}
		return constraintsModel;
	}

}
