package simple.dcsp.abtfamily.abt;

//import static simple.dcsp.abtfamily.abt.ABTMaster.NB_ASSIGNMENTS;
//import static simple.dcsp.abtfamily.abt.ABTMaster.OBSOLETE_NOGOOD;
//import static simple.dcsp.abtfamily.abt.ABTMaster.OBSOLETE_OK;

import java.util.HashMap;
import java.util.Iterator;

import kernel.MasterObserver;
import kernel.com.Message;
import util.Commands;
import util.Instantiation;

/**
 * termination detection (Silaghi et al. 2000)
 * 
 * @author redouane
 * 
 */
public class TerminationDetector extends MasterObserver {

	protected HashMap<Integer, Instantiation> acceptedMsgInitialEndAgents;
	protected int nbInitialEndAgents = 0;
	protected int nbRecIEA = 0;

	public TerminationDetector() {
		super();
		this.acceptedMsgInitialEndAgents = new HashMap<Integer, Instantiation>();
	}

	@Override
	public boolean handleReceivedMessage(Message msg) {
		Instantiation accepted = (Instantiation) msg.get(Commands.ACCEPTED);
		if (accepted != null) {
			this.acceptedMsgInitialEndAgents.put(msg.getSenderId(), accepted);
			if (this.allAcceptedMsgHaveBeenReceived()) {
				if (isAllcompatible()) {
					this.master.setEndState(Commands.SUCCESS);
					this.master.broadcastSystemMessage(0);
				}
			}
		} else if (msg.get(Commands.INITIAL_END_AGENT) != null) {
			nbRecIEA++;
			boolean ans = (Boolean) msg.get(Commands.INITIAL_END_AGENT);
			if (ans)
				this.nbInitialEndAgents++;
		}
		// }
		return true;
	}

	private boolean allAcceptedMsgHaveBeenReceived() {
		return nbRecIEA == this.master.getNumAgents() && this.acceptedMsgInitialEndAgents.keySet().size() == this.nbInitialEndAgents;
	}

	@SuppressWarnings("deprecation")
	private boolean isAllcompatible() {
		Iterator<Integer> it = this.acceptedMsgInitialEndAgents.keySet().iterator();
		Instantiation union = new Instantiation();
		while (it.hasNext()) {
			Instantiation ass = this.acceptedMsgInitialEndAgents.get(it.next());
			if (union.compatible(ass))
				union.merge(ass);
			else
				return false;
		}
		return true;
	}

	@Override
	public void handleSendMessage(Message msg) {}
}
