package simple.dcsp.abtfamily.abtdac;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import simple.Nogood;
import util.Commands;

public class NogoodsHandler extends MessageHandler {

	public NogoodsHandler(AbstractAgent agent) {
		super(agent, Commands.NOGOOD);
	}

	@Override
	public void processMessage(Message msg) throws StopException {
		Nogood nogood = (Nogood) msg.get(Commands.NOGOOD);
		int myValue = ((ABTdacAgent) this.myAgent).var.getValue();
		if (this.isCoherent(nogood)) {
			((ABTdacAgent) this.myAgent).makeNoGoodConstraint(nogood);
			((ABTdacAgent) this.myAgent).checkAddLink(nogood);
			((ABTdacAgent) this.myAgent).checkAgentView();
		} else {// re-send OK message.
			this.myAgent.auxiliaryStatistics.get(Commands.nbObsoleteNogood).value++;
			if (nogood.getRhsValue() == myValue) {
				((ABTdacAgent) this.myAgent).okMsgH.sendOkMessage(msg.getSenderId());
			}
		}
	}

	public void sendNogood(Nogood ng) {
		Message msg = this.createMessage();
		msg.addContents(Commands.NOGOOD, ng);
		msg.setReceiverId(ng.getRhsAgentId());
		this.myAgent.sendMessage(msg);
	}

	/**
	 * @param nogood
	 */
	public boolean isCoherent(Nogood nogood) {
		int myVal = ((ABTdacAgent) this.myAgent).var.getValue();
		return this.myAgent.agentView.compatibleWith(nogood.getLhs()) && nogood.getRhsValue() == myVal;
	}

}
