package simple.dcsp.abtfamily.abthyb;

import kernel.StopException;
import simple.Nogood;
import simple.dcsp.abtfamily.abt.ABTAgent;
import util.Commands;

public class ABTHybAgent extends ABTAgent {
	
	Nogood lastNogood ;
	boolean wait = false;

	public ABTHybAgent(int agentId, String agName, String description) {
		super(agentId, agName, description);
		this.okMsgH = new OkMessageHandler(this);
		this.ngdMsgH = new NogoodsHandler(this);
	}

	/**
	 * @throws StopException
	 */
	@Override
	public void backtrack() throws StopException {
		this.resolveContradiction();
	}
	/**
	 * 
	 */
	@Override
	public void resolveContradiction() throws StopException {
		Nogood nogood = this.solveMyNogoods();
		if (nogood.isEmpty()) { throw new StopException(Commands.FAILURE); }
		this.lastNogood = nogood.clone();
		this.wait = true;
		this.agentView.clear(nogood.getRhs());
		this.ngdMsgH.sendNogood(nogood);
	}

	@Override
	public boolean isIdle() {
		if (!this.var.isInstantiated())
			return false;
		return this.agentView.getContextsOfHigherAgents().size() == this.communicator.getHigherNeighbors().size();

	}

}
