package simple.dcsp.agileabt.explanation;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.VarAssignment;

public class AddLinkMsgHandler extends MessageHandler {

	public AddLinkMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ADDLINK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		int senderId = msg.getSenderId();
		this.myAgent.communicator.addNeighbor(senderId);
		VarAssignment myAss = (VarAssignment) msg.get(AgileABTAgent.LINK);
		if (myAss.getValue() != ((AgileABTAgent) this.myAgent).getMyVar().getValue()) {
			/* re-send OK message */
			Explanation myExp = ((AgileABTAgent) this.myAgent).getMyExplanation();
			((AgileABTAgent) this.myAgent).okMsgH.sendOkMessage(senderId, myExp);
		}
	}

	/**
	 * 
	 * @param ass
	 */
	public void sendAddLink(VarAssignment ass) {
		Message msg = this.createMessage();
		VarAssignment myAssignment = ((AgileABTAgent) this.myAgent).var.getVarAssignment();
		msg.addContents(AgileABTAgent.LINK, ass);
		msg.addContents(Commands.OK, myAssignment);
		msg.setReceiverId(ass.getAgentId());
		((AgileABTAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
