package simple.dcsp.agileabt.explanation;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.IntArray;
import util.Tools;

public class OrderMsgHandler extends MessageHandler {

	public OrderMsgHandler(AbstractAgent agent) {
		super(agent, Commands.ORDER);
	}

	@Override
	public void processMessage(Message msg) throws StopException {
		IntArray order = IntArray.fromString("" + msg.get(Commands.ORDER));
		double[] TV = Tools.DoubleArrayFromString("" + msg.get(AgileABTAgent.TV));
		((AgileABTAgent) this.myAgent).checkOrder(order, TV);
		((AgileABTAgent) this.myAgent).CheckAgentView();
	}

	/**
	 * 
	 * @param agId
	 */
	public void broadcastOrder(int agId) {
		IntArray order = this.myAgent.getOrder();
		String TV = Tools.arrayToString(((AgileABTAgent) this.myAgent).myTV);
		Message msg = createMessage();
		msg.addContents(Commands.ORDER, order.toString());
		msg.addContents(AgileABTAgent.TV, TV);
		order.remove(agId);
		order.remove(this.myAgent.agentId);
		for (int neig : order) {
			msg.setReceiverId(neig);
			((AgileABTAgent) this.myAgent).storeStatisticsFor(msg);
			this.myAgent.sendMessage(msg);
		}
	}
}
